%close all figures, clear workspace and turn off warnings
close all;
clear all;
warning off;

%start clocking time taken by tracking software
tic

%define a guassian function for use in smoothing and filtering
gauss=inline('exp(-(x-c).^2/2/s/s)','x','c','s');

%sundry constants and data
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\090605bac\rp1616-40ms-25fps-20ul.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\090605bac\RP9535-40ms-25fps-600.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\090605bac\rp437-50ms-20fps-15ul-1.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\090605bac\rp1616-50ms-20fps-15ul.tif'
% fn='C:\Documents and Settings\Mingming\MyDocuments\labwork\090605bac\rp1616-40ms-25fps-10ul.tif'
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\090605bac\rp2768-50ms-25fps-20ul.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\10_6_06\pflow3.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\12_8_05\L_25fps_40ms_400nm.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\12_8_05\L_30fps_25ms_400nm.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\12_8_05\K_25fps_40ms_400nm.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\12_8_05\K_30fps_25ms_400nm.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\12_8_05\I_30fps_25ms_400nm.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\090505\rp437-40ms-25fps-10ul.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\090505\RP9535-40ms-25fps-20ul-1.tif';
% fn='C:\Documents and Settings\Mingming\My Documents\labwork\bacteria movies\Aug_25\10.tif';
%fn='C:\Documents and Settings\Mingming\My Documents\labwork\bacteria movies\Aug_25\9.tif';
%fn='C:\Documents and Settings\Mingming\My Documents\labwork\26-09-05\RP1616-10ul-50ms-20fps-1.tif';
%fn='C:\Documents and Settings\Mingming\My Documents\labwork\03-oct-05\rp437-150ms-A-300-47s.tif';
%fn='C:\Documents and Settings\Mingming\My Documents\labwork\03-oct-05\rp437-150ms-A-300-47s-20ul.tif';

%set this to the number of .tif stacks to be tracked in this tracking run
stackNum=1;

%this look executes once for each .tif stack, with superI telling which
%stack will be tracked
for superI=1:stackNum

    %this switch chooses the file name used for the .tif stack
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%% ENTER TIF PATH HERE:    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %make sure to set names under which the tracked data will be saved at
    %the end of the file as well
    switch(superI)
        case 1
            fn='E:\labwork\10_6_06\med2.tif';
        case 2
            fn='E:\BX51-NBTC\03-nov-05\9535-5x-10-to-8m.tif';
        case 3
            fn='E:\BX51-NBTC\03-nov-05\9535-7x-10-to-8m.tif';
        case 4
            fn='E:\BX51-NBTC\03-nov-05\9535-10-to-8m.tif';
        case 5
            fn='E:\BX51-NBTC\03-nov-05\9535-10-to-9.tif';
%         case 6
%            fn='E:\BX51-NBTC\03-nov-05\9535-10-to-9.tif';
%         case 7
%             fn='C:\Documents and Settings\Mingming\My Documents\labwork\Nov 3, 2005\9535-10-to-7.tif';
%         case 8
%             fn='C:\Documents and Settings\Mingming\My Documents\labwork\Nov 3, 2005\9535-10-to-7.tif';
%         case 9
%             fn='C:\Documents and Settings\Mingming\My Documents\labwork\Nov 3, 2005\9535-10-to-7.tif';
%         case 10
%             fn='C:\Documents and Settings\Mingming\My Documents\labwork\Nov 3, 2005\9535-10-to-7.tif';
%         case 11
%             fn='C:\Documents and Settings\Mingming\My Documents\labwork\Nov 3, 2005\9535-10-to-7.tif';
%         case 12
%             fn='C:\Documents and Settings\Mingming\My Documents\labwork\Nov 3, 2005\9535-10-to-7.tif';
    end

    %this is the number of frames that will be tracked in this run
    %frames 1 through Nt will be used in the tracking
    Nt=1;
    
    %this is the first threshold, and does the following: If the two pixels
    %observed in the first filter (the ring mask stage) have a product
    %greater than threshold, they will be set to a one when making the
    %binary image used for the initial locating of particles.  Otherwise,
    %they will be set to a zero.  Raising this will in general find fewer
    %particles
    threshold=.005;
    % threshold=.01;   
    
    %this threshold is used in get_dup_circ, and is used to determine
    %whether or not two rings found near one another are in fact the same
    %ring.  Setting this higher will in general find fewer rings, as more
    %will be combined.
    proximity_threshold=8;
    
    %these are the low and high percentile pixels found in the mask-filter
    %stage of the tracker.  The values .25 and .5 are those commonly used.
    lowp=.25;
    highp=.5;

    
    
    % Generate a series of ring patterns
    
    %any pixel within thk/2 pixels of the true radius will be 
    %considered part of the ring in the mask. 
    thk=1.2; 
    
    %this is the minimum radius ring considered
    Nr_min=5;
    
    %this is the maximum radius ring considered
    Nr_max=39;
    
    %this uses ring_pat to generate a series of ring patterns held in the
    %structure pats.  Each integer radius will have its own entry in the
    %structure, from Nr_min to Nr_max
    pats=ring_pat(Nr_max,thk);

    
    
    % The shape of the local background ordered filter
    
    %filter size (filter always square
    nbf=12; 
    
    %make a filter mask of all ones
    bkfilt.mask=ones(nbf,nbf);
    
    %set the filter level to be .3 times the number of pixels observed
    bkfilt.level=floor(0.30*nbf*nbf);

    %set up variables for second-filter (using azimuthal average)
    global checkLocations;
    global checkLength;
    global maxSearchDisplacement;
    global pixels;
    
    %this is the maximum distance away from the guessed center the
    %azimuthal average will go when searcing
    maxSearchDisplacement=1;
    
    %this stores how long a region of the profile will be checked when looking
    %for the maximum.  It is set in the second loop below
    checkLength=0;
    
    %this stores a matrix of all the locations to look at, thus speeding
    %the process of performing the azimuthal average
    checkLocations=zeros(2,256);
    
    %this is a 2D array that holds, for each radius, the relative position
    %of each pixel that radius away from a center at 0,0.  It has the
    %format as follows:
    %row radius+1 is [number of pixels for this radius, c_value1, r_value1, ...]
    pixels=ones(100,320);

    %set up the pixel mask for the post filter, finding the pixels at
    %certain distances from a center at 0,0
    for i=-50:50;
        for j=-50:50
            temp=round(sqrt(i^2+j^2));
            pixels(temp+1,1)=pixels(temp+1,1)+2;
            pixels(temp+1,pixels(temp+1,1)-1)=i;
            pixels(temp+1,pixels(temp+1,1))=j;
        end
    end

    %set up the LUT for different radii in the azimuthal averaging filter
    %This will allow the filter to simply run through this list of
    %locations rather than check a large number of pixels and attempt to
    %determine which ones should be placed in the average and which ones
    %can be ignored.
    for i=0:maxSearchDisplacement
        for j=0:maxSearchDisplacement
            if round(sqrt(i^2+j^2))<=maxSearchDisplacement
                checkLength=checkLength+4;

                checkLocations(1,checkLength-3)=i;
                checkLocations(1,checkLength-3)=j;

                checkLocations(1,checkLength-2)=-i;
                checkLocations(1,checkLength-2)=j;

                checkLocations(1,checkLength-1)=i;
                checkLocations(1,checkLength-1)=-j;

                checkLocations(1,checkLength)=-i;
                checkLocations(1,checkLength)=-j;
            end
        end
    end

    % Main loop
    for jj=1:Nt

        %tell how many frames left
        display(sprintf('%d frames remaining...\n',Nt-jj+1))

        % Read an image from the specified .tif stack (image is in the
        % jj-th location of the stack)
        I1=imread(fn,'tif',jj);
        
        %grab a specified region of the picture to observe (in case of a
        %microfluidic or something similar)
        I1=I1(:,114:424);

        % Image processing: (pre-filter)
        %  Subtract background level, which is determined by local ordered
        %  filters; Enhance the contrast level
        [ni,nj]=size(I1);
        I1=im2double(I1);
        printout=I1;
        
        % run a gaussian filter on the image to smooth it out
        %filt=fspecial('gaussian',[5 5],0.8);
        %I1=imfilter(I1,filt,'symmetric');

        %run the background order filter on the image and subtract the
        %background.  Also use imadjust to enhance the contrast of the image 
        bk=ordfilt2(I1, bkfilt.level, bkfilt.mask, 'symmetric');
        I1=I1-bk;
        I1=I1.*(I1>0);
        nbin=floor(sqrt(ni*nj));
        [ht,xt]=hist(I1(:),nbin);
        ht=ht(2:nbin-1);    xt=xt(2:nbin-1);
        [mh,Ih]=max(ht);    bknoise=xt(Ih);
        I2=imadjust(I1,[bknoise 1],[0 1],0.3);
        I2(find(I2>.4))=median(I2(:));



        %cycle through radii that are being searched (ie go through each
        %mask for this particular image)
        
        %nc represents the number of particles located.  The others are the
        %x, y position and the radius
        nc=0;   xc=[];  yc=[];  rc=[];
        for j=Nr_min:Nr_max

            %set index number for low percentile and high percentile pixels
            %in median check
            lowm=floor(pats(j).NF*lowp);
            medm=floor(pats(j).NF*highp);

            %run 2-D order filter on data to generate medium and low
            %values for each pixel.  ordfilt2 reads in a mask (pats(j).H)
            %and sorts all the pixels in the image covered by the mask and
            %returns for each location the specified pixel in the list
            %(medm or lowm, depending on which percentile).
            t1=ordfilt2(I2,medm,pats(j).H,'symmetric');
            t2=ordfilt2(I2,lowm,pats(j).H,'symmetric');

            %generate correlation number for each pixel.  This is done
            %through multiplying the found medium percentile pixel and low
            %percentile pixel, taking the square root and normalizing.  The
            %extra .0001 is to avoid dividing by zero.
            tt=sqrt(t1.*t2)./(t1+t2+0.0001);

            %generate binary image with pixels above test threshold
            %as ones, all others as zeros
            binimg=double(tt> threshold);

            %ignore image if no pixels reached the needed threshold
            if(sum(binimg(:))<1)
                continue;
            end

            %use filter on binary image to locate particle positions
            %along with number of found pixels (pc), size of found particle
            %and so forth.
            [bin2,pc,px,py,psize]=filter_particle(binimg,tt);

            %as long as at least one was found, and not too many were found
            %store the x, y locations, along with r.  Also add to the
            %number of particles located for this image overall (nc)
            %the number of particles found for this radius (pc)
            if(pc>0&&pc<60)
                nc=nc+pc;
                xc=[xc reshape(px,1,pc)];
                yc=[yc reshape(py,1,pc)];
                rc=[rc ones(1,pc)*j];
            end
        end

        %if multiple rings are found within proximity_threshold of one
        %another, average them together and assume they came from the same
        %ring
        [xc,yc,rc]=get_dup_circ(xc,yc,rc,proximity_threshold);

        %a common error comes from a third ring being found at the
        %intersection of two overlapping ring.  This function attempts to
        %remove as many of these as possible
        [xc,yc,rc]=remove_circle(xc,yc,rc);

        %run aziumthal average based post-filter.  This returns updated
        %centers and radiis, along with the real check parameter which may
        %be used to eliminate some falsley found rings.
        [fC,fR]=multiSearch(I2,[xc yc],rc);

        %fun only if some things have been found
        if(~isempty(fC))
            %set x, y and r to the values returned from multisearch
            xc=fC(:,1);
            yc=fC(:,2);
            rc=fR;

            %store these results in a structure rlt containing the x, y and
            %r positions for each frame, as well as the number of particle
            %found here
            rlt(jj).x=xc;
            rlt(jj).y=yc;
            rlt(jj).r=rc;
            rlt(jj).nc=nc;

            %save a variable that holds the things found so far in case the
            %computer crashes or is turned off during a track.  This is
            %overwritten every frame, but will allow much data to be
            %recovered is something goes wrong late in the tracking
            save insureTrack rlt
        end
    end

    %this switch chooses the file name used for saving the data
    %for the .tif stack currently being tracked
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%% ENTER SAVE NAME HERE:   %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    switch(superI)
        case 1
            save temp rlt;
        case 2
            save E:\BX51-NBTC\03-nov-05\9535-5x-10-to-8m rlt;
        case 3
            save E:\BX51-NBTC\03-nov-05\9535-7x-10-to-8m rlt;
        case 4
            save E:\BX51-NBTC\03-nov-05\9535-10-to-8m rlt;
        case 5
           save E:\BX51-NBTC\03-nov-05\9535-10-to-9 rlt;
        case 6
            save 9535-10-to-9 rlt;
        case 7
            save 9535-10-to-7 rlt;
        case 8
            save 9535-10-to-7 rlt;
        case 9
            save 9535-10-to-7 rlt;
        case 10
            save 9535-10-to-7 rlt;
        case 11
            save 9535-10-to-7 rlt;
        case 12
            save 9535-10-to-7 rlt;
    end

end


%finish keeping track of time for this run and output elapsed time
toc