function [xi,yi,ri]=get_dup_circ(xi,yi,ri,md)

%reshape vectors into rows
ni=length(xi);
xi=reshape(xi,1,ni);
yi=reshape(yi,1,ni);
ri=reshape(ri,1,ni);

%cycle through number of circles to search for those that are
% "too close" to one another
for i=1:ni
    %find distances from first to all others (including self)
    dp=sqrt((xi-xi(1)).^2+(yi-yi(1)).^2);
    dr=abs(ri-ri(1));
    
    %store in I the indices for particles too close (always has self)
    I=find( ((dp<md).*(dr<md)) > 0);
    
    %store in J particles that are sufficantly far away
    J=find( ((dp>=md)+(dr>=md)) >0);
    
    %average particles that are too close and get one
    xn=mean(xi(I));
    yn=mean(yi(I));
    rn=mean(ri(I));
    
    %move current front particle to back, and store "individuals"
    %in front for testing
    xi=[xi(J) xn];
    yi=[yi(J) yn];
    ri=[ri(J) rn];    
end