function [I1,I2,dx,dy]=match_pair(x1,y1,x2,y2,r1,r2,max_dis)

I1=[];
I2=[];
dx=[];
dy=[];

[l1]=length(x1);
[l2]=length(x2);

if(l1==1 | l2==1 | l1==0 | l2==0 )
else
    
    

%pixel to micron scaling factors, p for pixel in plane, r
%is for pixels in the radius scaling to z motion
global p_scale;
global r_scale;

%store length for two different frames (1 and 2)
n1=length(x1);
n2=length(x2);

%create matrices of x and y locations
%for both the first and the second frame
xx1=reshape(x1,n1,1)*ones(1,n2);
yy1=reshape(y1,n1,1)*ones(1,n2);
rr1=reshape(r1,n1,1)*ones(1,n2);
xx2=ones(n1,1)*reshape(x2,1,n2);
yy2=ones(n1,1)*reshape(y2,1,n2);
rr2=ones(n1,1)*reshape(r2,1,n2);

%find square of the distance from particles
%in the first frame to particles in the second
rsquare=(p_scale*(xx1-xx2)).^2+(p_scale*(yy1-yy2)).^2+(r_scale*(rr1-rr2)).^2;

%find the closest particle to each particle
%with respect to the first image (indicies 
%refer to second image)
[mr,Jm]=min(rsquare');

%find the indices of the closest particle
%with respect to the particle in the second image
%(indicies refer to first image)
[mc,Im]=min(rsquare);

%list indicies
ind1=[1:n1];

%find those locations in which partners mutually agree on closeness and
%store their indicies with respect to image one (edit: no agreement)
I1=find( (Im(Jm) - ind1)==0 );

%transfer these to indicies with respect to image two
I2=Jm(I1);

%EDIT: NOW JUST FORWARD AND DISTANCE CHECKING
I1=[1:length(Jm)];
I2=Jm;

%compute the x, y and z displacments for those that agree
dx=p_scale*(x2(I2)-x1(I1));
dy=p_scale*(y2(I2)-y1(I1));
dz=r_scale*(r2(I2)-r1(I1));

%compute the distance and only keep those that are close enough to be
%resonable as matches
disp=sqrt(reshape(dx,length(I2),1).^2+reshape(dy,length(I2),1).^2+...
    reshape(dz,length(I2),1).^2);
I=find(disp<max_dis);

%get these indicies that are close enough for output
I1=I1(I);
I2=I2(I);
dx=dx(I);
dy=dy(I);
dz=dz(I);
end
